searchNodes=[{"doc":"Put your docs before your specs This can increase readability by a.) Enforcing consistent order b.) Putting the specs right next to the function head they describe","ref":"BlitzCredoChecks.DocsBeforeSpecs.html","title":"BlitzCredoChecks.DocsBeforeSpecs","type":"module"},{"doc":"Doctest examples should be indented by at least 4 spaces This allows ex_doc to render the example in a code block","ref":"BlitzCredoChecks.DoctestIndent.html","title":"BlitzCredoChecks.DoctestIndent","type":"module"},{"doc":"Avoid using imports where possible as they decrease readability and increase compile times When they must be used, use the keyword :only to restrict what is imported","ref":"BlitzCredoChecks.ImproperImport.html","title":"BlitzCredoChecks.ImproperImport","type":"module"},{"doc":"Do not uppercase first letter of a test name This is because the test name is appended to the end of the describe block name","ref":"BlitzCredoChecks.LowercaseTestNames.html","title":"BlitzCredoChecks.LowercaseTestNames","type":"module"},{"doc":"async: false doesn't do anything as tests are not async by default","ref":"BlitzCredoChecks.NoAsyncFalse.html","title":"BlitzCredoChecks.NoAsyncFalse","type":"module"},{"doc":"Do not use parentheses in DSLs provided by Ecto, Absinthe etc This also prevents accidental mass formattings from getting into the main branch (from a language server ignoring the .formatter for example)","ref":"BlitzCredoChecks.NoDSLParentheses.html","title":"BlitzCredoChecks.NoDSLParentheses","type":"module"},{"doc":"Use is_binary instead of is_bitstring There will be times where is_bitstring is appropriate, but most of the time it is because the developer is checking for a string and accidentally used the wrong guard See: https://elixir-lang.org/getting-started/binaries-strings-and-char-lists.html#binaries","ref":"BlitzCredoChecks.NoIsBitstring.html","title":"BlitzCredoChecks.NoIsBitstring","type":"module"},{"doc":"Ecto Repo calls can only be used within certain contexts, add modules under the :allowed_modules key in .credo.exs Does not apply to test files","ref":"BlitzCredoChecks.NoRampantRepos.html","title":"BlitzCredoChecks.NoRampantRepos","type":"module"},{"doc":"All test helpers need to set :warnings_as_errors to true This catches things like unused variables, which can be an indication that the developer forgot to pin (^) a variable in a pattern match. And also, clean up your warnings, we arn't living in a barn!","ref":"BlitzCredoChecks.SetWarningsAsErrorsInTest.html","title":"BlitzCredoChecks.SetWarningsAsErrorsInTest","type":"module"},{"doc":"Use ===/2 instead of ==/2 and !==/2 instead of !=/2 for strict float comparison. See https://elixirschool.com/en/lessons/basics/basics#comparison-12","ref":"BlitzCredoChecks.StrictComparison.html","title":"BlitzCredoChecks.StrictComparison","type":"module"},{"doc":"Todos in codebase need an associated ticket URL i.e. Todo: Make this better https://linear.app/company/issue/443","ref":"BlitzCredoChecks.TodosNeedTickets.html","title":"BlitzCredoChecks.TodosNeedTickets","type":"module"},{"doc":"Use Stream functions instead of piping multiple Enum functions together This can reduce memory usage, especially in the case of long chains of Enum functions See: https://hexdocs.pm/elixir/Stream.html","ref":"BlitzCredoChecks.UseStream.html","title":"BlitzCredoChecks.UseStream","type":"module"},{"doc":"Checks all files that have been changed from trunk. Great for gradually introducing conventions through enforcement on new code only. Run this task with mix credo_diff Flags --trunk the branch that the current one will be compared against for files. Defaults to main . --name The configuration in .credo.exs to use, defaults to default .","ref":"Mix.Tasks.CredoDiff.html","title":"Mix.Tasks.CredoDiff","type":"task"},{"doc":"It's clunky but each file name has to be appended one at a time","ref":"Mix.Tasks.CredoDiff.html#build_credo_args/2","title":"Mix.Tasks.CredoDiff.build_credo_args/2","type":"function"},{"doc":"There will be other files but we only want to check Elixir","ref":"Mix.Tasks.CredoDiff.html#filter_elixir_files/1","title":"Mix.Tasks.CredoDiff.filter_elixir_files/1","type":"function"},{"doc":"Print any errors we see and error if there is a non-zero exit code","ref":"Mix.Tasks.CredoDiff.html#parse_credo_output/2","title":"Mix.Tasks.CredoDiff.parse_credo_output/2","type":"function"},{"doc":"If we don't get files then there is nothing to check","ref":"Mix.Tasks.CredoDiff.html#parse_git_diff_output/1","title":"Mix.Tasks.CredoDiff.parse_git_diff_output/1","type":"function"},{"doc":"A set of custom checks used by the Blitz Backend Elixir team on top of the excellent ones included with Credo . We use these checks to catch errors, improve code quality, maintain consistency, and shorten pull request review times. Check the moduledocs inside the check modules themselves for details on the individual checks.","ref":"README.md.html","title":"BlitzCredoChecks","type":"extras"},{"doc":"1. Add dependencies Add Credo (required to run the checks) and BlitzCredoChecks to your project dependencies by adding the following to your mix.exs defp deps do [ { :credo , &quot;~&gt; 1.6&quot; , only : [ :dev , :test ] , runtime : false } , { :blitz_credo_checks , &quot;~&gt; 0.1&quot; , only : [ :dev , :test ] , runtime : false } ] end 2. Create configuration file If you do not have one already in the root of your project, a default Credo configuration file .credo.exs can be generated with mix credo.gen.config 3. Add these checks Add some or all of these checks under the checks key in .credo.exs checks : [ # Custom checks { BlitzCredoChecks.DocsBeforeSpecs , [ ] } , { BlitzCredoChecks.DoctestIndent , [ ] } , { BlitzCredoChecks.LowercaseTestNames , [ ] } , { BlitzCredoChecks.NoAsyncFalse , [ ] } , { BlitzCredoChecks.NoDSLParentheses , [ ] } , { BlitzCredoChecks.NoIsBitstring , [ ] } , { BlitzCredoChecks.SetWarningsAsErrorsInTest , [ ] } , { BlitzCredoChecks.StrictComparison , [ ] } , { BlitzCredoChecks.UseStream , [ ] } , { BlitzCredoChecks.ImproperImport , [ ] } , { BlitzCredoChecks.NoRampantRepos , [ ] } , { BlitzCredoChecks.TodosNeedTickets , ticket_url : &quot;https://linear.app/company/issue/&quot; } , # ... all the other checks that come with Credo ] 4. Run Credo mix credo","ref":"README.md.html#using-these-checks","title":"BlitzCredoChecks - Using these checks","type":"extras"},{"doc":"This library also contains Mix.Tasks.CredoDiff which can run Credo checks across the subset of files that differ from a branch like main . This can be useful for incrementally improving the codebase through only applying certain checks on files that are currently being edited. mix credo_diff --trunk main --name stricter_checks See Mix.Tasks.CredoDiff for more details.","ref":"README.md.html#credodiff","title":"BlitzCredoChecks - CredoDiff","type":"extras"},{"doc":"We welcome contributions to this library. Bear in mind however that new checks can be very controversial as they have a large impact on developer experience. We therefore recommend that you open an issue to discuss a new check before beginning work on a new one. Getting set up locally Consider opening an issue for discussion Fork and clone this repository on GitHub Install elixir and erlang versions with asdf asdf install Fetch dependencies mix deps.get Run the test suite mix check Use your work in another project It is an excellent idea to not just write tests, but to also run your check against another codebase. Include your cloned project under deps in the mix.exs of your other codebase { :blitz_credo_checks , path : &quot;/home/username/dev/blitz_credo_checks/&quot; } And fetch your dependencies to pull in the local version you are working on mix deps.get Hiring Are you looking for a new gig?? We're looking for mid-level to senior level developers to join our team and continue growing our platform while building awesome software! Come join us at Blitz.gg","ref":"README.md.html#contributing","title":"BlitzCredoChecks - Contributing","type":"extras"},{"doc":"","ref":"CHANGELOG.md.html","title":"Changelog","type":"extras"},{"doc":"","ref":"CHANGELOG.md.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Make Credo available for prod build to resolve OTP 25 errors on release Update OTP/Elixir versions Minor dependency updates","ref":"CHANGELOG.md.html#v0-1-5-2022-05-26","title":"Changelog - v0.1.5 (2022-05-26)","type":"extras"},{"doc":"Fix CI checks names Enforce that indentation is at least 4 characters in BlitzCredoChecks.DoctestIndent","ref":"CHANGELOG.md.html#v0-1-4-2022-04-25","title":"Changelog - v0.1.4 (2022-04-25)","type":"extras"},{"doc":"Fix print statements not showing in console for credo_diff errors","ref":"CHANGELOG.md.html#v0-1-3-2022-04-12","title":"Changelog - v0.1.3 (2022-04-12)","type":"extras"},{"doc":"Added check BlitzCredoChecks.TodoNeedsTickets","ref":"CHANGELOG.md.html#v0-1-2-2022-04-12","title":"Changelog - v0.1.2 (2022-04-12)","type":"extras"},{"doc":"Added CredoDiff task that runs Credo on files that have changed from trunk Added checks BlitzCredoChecks.ImproperImport BlitzCredoChecks.NoRampantRepos","ref":"CHANGELOG.md.html#v0-1-1-2022-04-11","title":"Changelog - v0.1.1 (2022-04-11)","type":"extras"},{"doc":"Added checks BlitzCredoChecks.DocsBeforeSpecs BlitzCredoChecks.DoctestIndent BlitzCredoChecks.LowercaseTestNames BlitzCredoChecks.NoAsyncFalse BlitzCredoChecks.NoDSLParentheses BlitzCredoChecks.NoIsBitstring BlitzCredoChecks.SetWarningsAsErrorsInTest BlitzCredoChecks.StrictComparison BlitzCredoChecks.UseStream General documentation and tooling","ref":"CHANGELOG.md.html#v0-1-0-2022-04-08","title":"Changelog - v0.1.0 (2022-04-08)","type":"extras"},{"doc":"Created the project!","ref":"CHANGELOG.md.html#created-repo-2022-04-07","title":"Changelog - Created Repo (2022-04-07)","type":"extras"}]